﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Threading.Tasks;
using System.ServiceModel;
using System.ServiceModel.Description;

namespace WCFHost
{
    public partial class UTCTimeService : ServiceBase
    {
        private ServiceHost service_host = null;
        public UTCTimeService()
        {
            InitializeComponent();
        }

        protected override void OnStart(string[] args)
        {
            //конфигурация хоста  
            if (service_host != null) service_host.Close();

            string address_HTTP = "http://localhost:9001/UTCTimeService";
             

            Uri[] address_base = { new Uri(address_HTTP) };
            service_host = new ServiceHost(typeof(WCFServiceLibrary.Service.UTCTimeService), address_base);

            ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
            service_host.Description.Behaviors.Add(behavior);

            BasicHttpBinding binding_http = new BasicHttpBinding();
            service_host.AddServiceEndpoint(typeof(WCFServiceLibrary.Contract.IUTCTimeService), binding_http, address_HTTP);
            service_host.AddServiceEndpoint(typeof(IMetadataExchange), MetadataExchangeBindings.CreateMexHttpBinding(), "mex");
             
            service_host.Open();
        }

        protected override void OnStop()
        {
            if (service_host != null)
            {
                service_host.Close();
                service_host = null;
            }
        }
    }
}
